/* 	Base64Decoder.java
 *	Copyright (c) 2006, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 7-dec-2006
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * TODO Are we allowed to use sun.misc.BASE64Decoder here?		
 */
package org.brains2b.coffee.decode;

import java.io.File;

import org.brains2b.coffee.message.local.FileMessage;
import org.brains2b.util.StringHelper;

import sun.misc.BASE64Decoder;

/**
 * Decode Base64 encoded text to binary
 * 
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 1.00 [07-12-2006]
 */
public class Base64Decoder implements Decoder {

	StringBuffer m_buffer;
	BASE64Decoder m_decoder;
	String m_fileName;

	/**
	 * Constructor
	 * @param fileName String, fileName for the 
	 * decoded bytes
	 */
	public Base64Decoder(String fileName) {
		m_fileName = StringHelper.stripper(fileName, '"');
		m_buffer = new StringBuffer();
		m_decoder = new BASE64Decoder();
	}

	public void decodePiece(String s) throws Exception {
		m_buffer.append(s);
	}

	public FileMessage getFileMessage() throws Exception {
		byte[] b = m_decoder.decodeBuffer(m_buffer.toString());
		m_buffer = null;
		FileMessage fm = new FileMessage();
		fm.setFile(new File(m_fileName));
		fm.setData(b);
		return fm;
	}

}
