/* 	CfEditPane.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 15-jan-2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.gui;

import java.awt.Dimension;
import java.awt.FontMetrics;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.text.DefaultEditorKit;

import org.brains2b.coffee.message.ArticleBody;

public class CfEditPane extends JEditorPane {

   
    public CfEditPane() {
        super();
        getDocument().putProperty( DefaultEditorKit.EndOfLineStringProperty, "\r\n" );
        init();
    }
    
    public void setBody(ArticleBody ab) {
        if (ab!=null)
        setText(ab.getContent());
    }
    
    public ArticleBody getBody() {
        ArticleBody body= new ArticleBody();
        body.addLine(getText());
        return body;
    }
    
    private void init() {
    	setBorder(BorderFactory.createEmptyBorder(2, 5, 2, 5));
     	createPreferredSize(this, 70, 20);   
    }
    
    private void createPreferredSize(JComponent c,int columns, int lines) {
    	FontMetrics fm = c.getFontMetrics(c.getFont());
    	c.setPreferredSize(new Dimension((int) (fm.getMaxAdvance()*columns/2),lines*fm.getHeight()+7));
    	c.setMinimumSize(new Dimension((int) (fm.getMaxAdvance()*columns/4),lines*fm.getHeight()+7));
    }
}
