/* 	DropNewsGroup.java
 *	Copyright (c) 2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Feb 26, 2008
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.gui.dnd;

import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;

import org.brains2b.coffee.TicketBroker;
import org.brains2b.coffee.gui.list.ExtMutableList;
import org.brains2b.coffee.message.NewsGroup;
import org.brains2b.coffee.message.local.Subscription;

/** DropTarget for DnD of Newsgroup in CoffeeBreak internally
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.90 [26-02-2008]
 */
public class DropNewsGroup extends DropTargetAdapter {

	private ExtMutableList m_list;
	
	public DropNewsGroup(ExtMutableList l) {
		super();
		m_list = l;
	}
	
	public void drop(DropTargetDropEvent dtde) {
		if (dtde.isLocalTransfer()) {
			dtde.acceptDrop(DnDConstants.ACTION_COPY);
			Transferable t = dtde.getTransferable();
			try {
				NewsGroup grp = (NewsGroup) t.getTransferData(t.getTransferDataFlavors()[0]);
				m_list.addItem(Subscription.createSubscription(grp, TicketBroker.getBroker().getCurrentServer()));
				dtde.dropComplete(true);
			} catch (Exception ex) {
				dtde.dropComplete(false);	
			}
			
			return;	
		}
		dtde.rejectDrop();
	}

}
