/* 	MutableListModel.java
 *	Copyright (c) 2007-2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Sept 4, 2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * Feb 26, 2008	dennis@brains2b.nl		made fireContentsChanged public to allow remove in ExtMutableList		
*/
package org.brains2b.coffee.gui.list;

import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;

public class MutableListModel extends AbstractListModel {

    ArrayList m_data;
    
    public MutableListModel() {
        super();
    }
    
    public Object getElementAt(int index) {
        if (m_data==null) {
            return null;
        }
        return m_data.get(index);
    }

    public int getSize() {
        return m_data==null?0:m_data.size();
    }
    
    public void setData(List l) {
    	if (l==null) {
    		if (m_data!=null) m_data.clear();
    		return;
    	}
        m_data=new ArrayList();
        m_data.addAll(l);
        fireContentsChanged(this, 0, m_data.size());
    }
    
    public void addData(Object data) {
       if (m_data==null) {
        m_data = new ArrayList();
    }
       m_data.add(data);
       fireIntervalAdded(this, m_data.size()-1, m_data.size());
    }
    
    public Object[] getData() {
        if (m_data==null) {
            return null;
        }
        Object[] result= new Object[m_data.size()];
        m_data.toArray(result);
        return result;
    }
    
    public void removeData(int index) {
        if (index>=0 && m_data!=null && index<m_data.size()) {
            m_data.remove(index);
            fireIntervalRemoved(this,index, index);
        }
    }
    
    public void fireContentsChanged(Object source, int index0, int index1) {
    	super.fireContentsChanged(source, index0, index1);
    }
}