/**
 * 
 */
package org.brains2b.coffee.gui.table;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;

import org.brains2b.swingext.gui.IconFactory;

public class ArticleColumnModel extends DefaultTableColumnModel {
	
	class HeaderCellRenderer extends DefaultTableCellRenderer {
	
	    public HeaderCellRenderer() {
	        super();
	        setHorizontalAlignment(CENTER);
	        setBorder(UIManager.getBorder("TableHeader.cellBorder"));
	    }
	    
	    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
	       final int order = ((ArticleTreeTableModel) table.getModel()).getSortIndex();
	       
	       if (Math.abs(order)-1==column) {
	           if (order>0) {
	               setIcon(IconFactory.createIcon("/org/brains2b/coffee/resource/down9x9.png"));
	           } else {
	               setIcon(IconFactory.createIcon("/org/brains2b/coffee/resource/up9x9.png"));
	           }
	           setHorizontalTextPosition(SwingConstants.LEFT);
	       } else {
	           setIcon(null);
	       }
	       JTableHeader header = table!=null?table.getTableHeader():null;
	       if (header!=null) {
	           setFont(header.getFont());
	           setForeground(header.getForeground());
	           setBackground(header.getBackground());
	       }
	       setValue(value);
	       return this;
	    }
	    
	}

	private int m_idx;
	private HeaderCellRenderer m_headerRender;
	
	public ArticleColumnModel() {
	 	super();
	 	m_headerRender= new HeaderCellRenderer();
	 	addColumn(70,"Title");
	 	addColumn(20,"Author");
	 	addColumn(10,"Date");
	 	addColumn(5,"Size");
	 	addColumn(4,"Parts");
	 	
	}
	
	private void addColumn(int charwidth,String title) {
	    TableColumn col=new TableColumn(m_idx++,charwidth*10);
	    col.setHeaderRenderer(m_headerRender);
	    col.setHeaderValue(title);
	    addColumn(col);
	}
	    	
}