/* 	Body.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 17-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.message;

import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class ArticleBody implements NNTPMessage {

    private boolean m_headerSet;
   
    private StringBuffer m_buffer;
    /**
     * 
     */
    public ArticleBody() {
        super();
        m_buffer=new StringBuffer();
    }

    public String getContent() {
        return m_buffer.toString();
    }
    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#addLine(java.lang.String)
     */
    public void addLine(String s) {
        m_buffer.append(s);

    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#addHeader(int, java.lang.String)
     */
    public void addHeader(int id, String s) {
        int idx=s.indexOf(' ');
        /*if (idx>0) {
            m_number=Integer.parseInt(s.substring(0,idx).trim());
        }*/
        int last=idx+1;
        idx=s.indexOf(' ',last);
        /*if (idx>0) {
            m_id=s.substring(0,idx).trim();
        }*/
        m_headerSet=true;

    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#isHeaderSet()
     */
    public boolean isHeaderSet() {
        return m_headerSet;
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#endMessage()
     */
    public void endMessage() {
        
    }
    
    public int getType() {
        return 222;
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#writeMessage(org.brains2b.saxo.SAXWriter)
     */
    public void writeMessage(SAXWriter sw) throws SAXException {
        sw.startElement("body",null);
        StringBuffer sb= new StringBuffer(m_buffer.length()+12);
        sb.append("<![CDATA[").append(m_buffer).append("]]>");
        sw.setContent(sb.toString());
        sw.endElement("body");

    }
    
    public boolean hasContent() {
        return m_buffer.length()>0;
    }
    
    public int getSize() {
        return m_buffer.length();
    }
    
    public String getId() {
        return "body";
    }
}
