package org.brains2b.coffee.message.local;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.brains2b.saxo.SAXWriter;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

public class Identity implements CoffeeBean {

	private String m_id;
	private String m_from;
	private int m_tagline;
	private List m_tagLines;
	private HashMap m_headers;
	
	public Identity() {
		super();
		m_tagLines = new ArrayList();
	}
		
	public void setAttributes(Attributes atts) {
		m_id = atts.getValue("id");
		m_tagline=-1;
		String s=atts.getValue("tagline");
		if (s!=null) {
			m_tagline=Integer.parseInt(s);
		}
	}

	public void setContent(String name, String value) {
		setContent(name,null, value);
	}
	
	public void setContent(String name, Attributes a,  String value) {
		if ("from".equals(name)) {
			m_from=value;
		} else if ("tagline".equals(name)) {
			m_tagLines.add(value);
		} else if ("header".equals(name)) {
			m_headers.put(a.getValue("id"),value);
		}
		
	}
	
	public String getId() {
		return m_id;
	}

	public int getSize() {
		return 1;
	}

	public int getType() {
		return 7003;
	}

	public boolean hasContent() {
		return true;
	}

	public boolean isHeaderSet() {
		return false;
	}

	public void writeMessage(SAXWriter sw) throws SAXException {
		AttributesImpl atts= new AttributesImpl();
		atts.addAttribute(null, "id", "id", "CDATA", m_id);
		atts.addAttribute(null, "tagline", "tagline", "CDATA", String.valueOf(m_tagline));
		sw.startElement("identity", atts);
		sw.startElement("from", null);
		sw.setContent(m_from);
		sw.endElement("from");
		if (m_tagLines!=null)
		for (Iterator it = m_tagLines.iterator();it.hasNext();) {
			sw.startElement("tagline", null);
			sw.setContent((String) it.next());
			sw.endElement("tagline");
		}
		if (m_headers!=null)
		for (Iterator it = m_headers.keySet().iterator();it.hasNext();) {
			String key = (String) it.next();
			AttributesImpl hatts= new AttributesImpl();
			hatts.addAttribute(null, "id", null, "CDATA", key);
			sw.startElement("header", hatts);
			sw.setContent((String) m_headers.get(key));
			sw.endElement("header");
		}
		

	}

	public String getFrom() {
		return m_from;
	}

	public HashMap getHeaders() {
		return m_headers;
	}

	public int getTagline() {
		return m_tagline;
	}

	public List getTagLines() {
		return m_tagLines;
	}

	public void setId(String id) {
		m_id = id;
	}

	public void addHeader(int id, String s) {
	}

	public void addLine(String s) {
	}

	public void endMessage() {
	}

	public void setTagLines(List tagLines) {
		m_tagLines = tagLines;
	}

	public String toString() {
        return getId();
    }
}
