/* 	NewsSearchMap.java
 *	Copyright (c) 2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Feb 25, 2008
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.plugin.search;

import java.awt.event.ActionListener;

import org.brains2b.swingext.action.ExtActionMap;

/**
 * ActionMap for {@link NewsSearch} GUI view
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.90 [25-02-2008]
 */
public class NewsSearchMap extends ExtActionMap {

	/**
	 * Constructor
	 * @param l {@link ActionListener} to handle 
	 * these actions
	 */
	public NewsSearchMap(ActionListener l) {
		super(l);
		init();
	}
	
	private void init() {
		addAction("query.new", "", "Add a new query", "/org/brains2b/coffee/resource/New16.gif", "Ctrl N", 'n');
        addAction("query.delete","", "Remove a query", "/org/brains2b/coffee/resource/Remove16.gif","Ctrl D", 'd');
        addAction("list.add", "", "Add a new query statement", "/org/brains2b/coffee/resource/Plus16.gif", "Ctrl Shift A", 'n');
        addAction("list.delete","", "Remove query statement", "/org/brains2b/coffee/resource/Remove16.gif","Ctrl Shift D", 'd');
        addAction("glist.add", "", "Add a newsgroup", "/org/brains2b/coffee/resource/Plus16.gif", "Ctrl Shift +", 'n');
        addAction("glist.delete","", "Remove newsgroup", "/org/brains2b/coffee/resource/Remove16.gif","Ctrl Shift -", 'd');
        addAction("query.refresh","",null,"/org/brains2b/coffee/resource/Refresh16.gif","ctrl r",'r');
	}
}
