/* 	GroupListTest.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 17-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.message;

import java.io.FileWriter;

import junit.framework.TestCase;

import org.brains2b.coffee.message.GroupList;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.nntp.NNTPConnector;
import org.brains2b.saxo.SAXWriter;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class GroupListTest extends TestCase {

    public static void main(String[] args) {
       	
        junit.swingui.TestRunner.run(GroupListTest.class);
    }

    /**
     * Constructor for GroupListTest.
     * @param name
     */
    public GroupListTest(String name) {
        super(name);
        
    }

    public void testGetLiveList() {
        NNTPConnector conn=new NNTPConnector("newszilla.xs4all.nl",119);
        try {
            conn.connect();
        	NNTPMessage message=conn.invoke("LIST","active");
        	if (message instanceof GroupList) {
        	    FileWriter fw=new FileWriter(System.getProperty("java.io.tmpdir")+"/newsgroups.xml");
        	    SAXWriter sw=new SAXWriter(fw);
        	    sw.startDocument();
        	    sw.insertDescriptor();
        	    ((GroupList) message).writeMessage(sw);
        	    sw.endDocument();
        	} else {
        	    assertTrue(message.toString(),false);
        	}
        } catch (Exception ex) {
            ex.printStackTrace();
            assertTrue(ex.getMessage(),false);
        } finally {
            try {
            	conn.close();
            } catch (Exception ex) {
                
            }
        }
        
    }
}
