/* 	CfDateHelperTest.java
 *	Copyright (c) 2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Apr 9, 2008
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.util;

import java.util.Calendar;

import org.brains2b.coffee.util.CfDateHelper;
import org.brains2b.util.StringHelper;

import junit.framework.TestCase;

/** junit test for org.brains2b.coffee.util.CfDateHelper
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.10 [Apr 9, 2008]
 * @see org.brains2b.coffee.util.CfDateHelper
 */
public class CfDateHelperTest extends TestCase {

	public void testParse() {
		Calendar c = Calendar.getInstance();
		c.clear();
		for (int i=0;i<33;i++) {
			c.set(2008, 2, 18, 10, 28,i);
			assertEquals(c.getTime(),CfDateHelper.parse("Tue, 18 Mar 2008 11:28:" + StringHelper.leftPad(String.valueOf(i),"0",2) +" +0200"));
		}
		c.clear();
		c.set(2008,2,26,21,45,55);
		assertEquals(c.getTime(),CfDateHelper.parse("Wed, 26 Mar 2008 21:45:55 +0100"));
	}

	public void testFormat() {
		Calendar c = Calendar.getInstance();
		c.clear();
		for (int i=0;i<33;i++) {
			c.set(2008, 2, 18, 11, 28,i);
			assertEquals("Tue, 18 Mar 2008 11:28:" + StringHelper.leftPad(String.valueOf(i),"0",2) +" +0100",CfDateHelper.format(c.getTime()));
		}
	}

}
